// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockAgentSessions is an autogenerated mock type for the AgentSessions type
type MockAgentSessions struct {
	mock.Mock
}

// CreateAgentSession provides a mock function with given fields: ctx, session
func (_m *MockAgentSessions) CreateAgentSession(ctx context.Context, session *models.AgentSession) (*models.AgentSession, error) {
	ret := _m.Called(ctx, session)

	if len(ret) == 0 {
		panic("no return value specified for CreateAgentSession")
	}

	var r0 *models.AgentSession
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.AgentSession) (*models.AgentSession, error)); ok {
		return rf(ctx, session)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.AgentSession) *models.AgentSession); ok {
		r0 = rf(ctx, session)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.AgentSession)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.AgentSession) error); ok {
		r1 = rf(ctx, session)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteAgentSession provides a mock function with given fields: ctx, session
func (_m *MockAgentSessions) DeleteAgentSession(ctx context.Context, session *models.AgentSession) error {
	ret := _m.Called(ctx, session)

	if len(ret) == 0 {
		panic("no return value specified for DeleteAgentSession")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.AgentSession) error); ok {
		r0 = rf(ctx, session)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetAgentSessionByID provides a mock function with given fields: ctx, id
func (_m *MockAgentSessions) GetAgentSessionByID(ctx context.Context, id string) (*models.AgentSession, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetAgentSessionByID")
	}

	var r0 *models.AgentSession
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.AgentSession, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.AgentSession); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.AgentSession)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetAgentSessionByPRN provides a mock function with given fields: ctx, prn
func (_m *MockAgentSessions) GetAgentSessionByPRN(ctx context.Context, prn string) (*models.AgentSession, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetAgentSessionByPRN")
	}

	var r0 *models.AgentSession
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.AgentSession, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.AgentSession); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.AgentSession)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetAgentSessions provides a mock function with given fields: ctx, input
func (_m *MockAgentSessions) GetAgentSessions(ctx context.Context, input *GetAgentSessionsInput) (*AgentSessionsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetAgentSessions")
	}

	var r0 *AgentSessionsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetAgentSessionsInput) (*AgentSessionsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetAgentSessionsInput) *AgentSessionsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*AgentSessionsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetAgentSessionsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateAgentSession provides a mock function with given fields: ctx, session
func (_m *MockAgentSessions) UpdateAgentSession(ctx context.Context, session *models.AgentSession) (*models.AgentSession, error) {
	ret := _m.Called(ctx, session)

	if len(ret) == 0 {
		panic("no return value specified for UpdateAgentSession")
	}

	var r0 *models.AgentSession
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.AgentSession) (*models.AgentSession, error)); ok {
		return rf(ctx, session)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.AgentSession) *models.AgentSession); ok {
		r0 = rf(ctx, session)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.AgentSession)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.AgentSession) error); ok {
		r1 = rf(ctx, session)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockAgentSessions creates a new instance of MockAgentSessions. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockAgentSessions(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockAgentSessions {
	mock := &MockAgentSessions{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
